#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "dacf.h"

struct  hinfo *spc[NSPEC+1], *hptr;      /* histogram information */
extern char *getenv();
char *pspath;

main()
{
  char confname[32];
  FILE *fp, *fopen();
  int id[2];
  register i;
  int shmflg = SHM_RND;
  int *ret;
  int *master;
  float *hdat;

  if((pspath = getenv("HOME")) != NULL) {
    strcpy(confname,pspath);
    strcat(confname,"/SHM.conf");
  }
  else
    strcpy(confname,"SHM.conf");

  if((fp = fopen(confname, "r")) == NULL) {
    printf("\n <==  NO SHARED MEMORY CONFIGURATION FILE FOUND  ==> \n");
    exit(0);
  }
  fscanf(fp,"%*s %*s %*s %*s %*s %d %d", &id[0],&id[1]);
  fclose(fp);

  if(id[0] > 0) {
    printf("check ID: %d\n",id[0]);
    if((spc[0] = (struct hinfo *) shmat(id[0], 0, shmflg)) ==
     (struct hinfo *) -1) {
      perror("attach hinfo segment");
      exit(1);
    }
    for(i=0;i <= NSPEC;i++)	/* initialize pointer array */
      spc[i] = spc[i-1] + 1;
    shmdt(spc[0]);
  }
  if(id[1] > 0) {
    printf("check ID: %d\n",id[1]);
    if((hdat = (float *) shmat(id[1], 0, shmflg)) == (float *)-1) {
      perror ("attach data segment");
      exit(1);
    }
    for(i=0;i<HSIZ;i++)
      hdat[i] = 0;
    shmdt(hdat);
  }
  printf("\n                <== TEST COMPLETE ==>\n");
}
