/*   Sample file to write data in SA format */

#include <stdio.h>
#include "dacf.h"		/* SA definitions */

#define N  20			/* set proper size for data array */
int hdata[N*1024];		/* data array */
char filnam[64];		/* output file name */

struct filehead flhd = {"his/"};	/* file head structure */

main()
{
    register i;
    int fd;
    int len;

/* here read in your ASCII data and store them in hdata,
several spectra can be put in hdata.
Example with 2 spectra of the same length:
Spectrum 1  starts at hdata[0] and is 2048 channels long
Spectrum 2  follows (start at hdata[2048] and is 2048 channels long.
*/
    len = 4096;
/* Set up fileheader and write out as integers */

    printf("Output file name: ");
    gets(filnam);
 
    if ((fd = creat (filnam, 0644)) < 0) {  /* open disk file */
      fprintf (stderr,"error opening %s\n", filnam);
      exit(1);
    }
    strncpy (&flhd.name[5], filnam, 10);	/* original data file name */
    flhd.name[15] = '\0';			/* allways zero */

    flhd.nrun = 1;		                /* can be any number */
    flhd.dtype = 0;				/* int */
    flhd.len = len;			        /* total length */
    flhd.maxid = 2;			        /* # of spectra (id's) */

    for (i = 0; i < flhd.maxid; i++) {
	flhd.sinfo[i].id = i+1;
	flhd.sinfo[i].offs = i * 2048;
    }

    for (i++ ; i< NSPEC; i++) {
	flhd.sinfo[i].id = 0;
	flhd.sinfo[i].offs = 0;
    }
    write (fd, &flhd, sizeof (flhd));
    write (fd, hdata, flhd.len<<2);
    close (fd);
}
